bool SendCustomEvent(const string &in title, array<string> data) {
	auto app = cast<CTrackMania>(GetApp());
	auto network = cast<CTrackManiaNetwork>(app.Network);
	auto maniaApp = cast<CGameManiaAppPlayground>(network.ClientManiaAppPlayground);
	if (maniaApp is null) {
		error("ManiaApp was null whilst trying to send event");
		return false;
	}

	MwFastBuffer<wstring> eventData;
	for (uint i = 0; i < data.Length; i++) {
		eventData.Add(data[i]);
	}
	maniaApp.SendCustomEvent(title, eventData);
	/* @debug
	string logString = "Sent" + title + " (";
	for (uint i = 0; i < eventData.Length; i++) {
		if (i > 0) logString += ", ";
		logString += eventData[i];
	}
	trace(logString + ")");
	*/
	return true;
}
