Inputs@ g_inputs = Inputs();

class Inputs {
	// Chat inputs, to be managed by Twitch Loop
	array<uint64> m_InputsLeft;
	array<uint64> m_InputsRight;
	array<uint64> m_InputsBackward;
	array<uint64> m_InputsForward;
	bool m_InputRespawn;

	// Applied inputs
	float m_inputSteer;
	float m_inputBrake;
	bool m_inputAccelerate;
}

void InputsLoop() {
	uint64 nextApply = Time::Now;
	while (true) {
		if (g_twitchPlays.m_isActive) {
			if (Time::Now > nextApply) {
				nextApply = Time::Now + 250;

				// steering
				int steerInputCount = g_inputs.m_InputsLeft.Length + g_inputs.m_InputsRight.Length;
				g_inputs.m_inputSteer = (g_inputs.m_InputsRight.Length - g_inputs.m_InputsLeft.Length) / (Math::Max(steerInputCount, 1));

				// accel / brake
				// 100% accel (default): 0.0 brake 1 accel
				// 50 / 50: 0.0 brake 0 accel
				// 100% brake: 0.65 brake 0 accel
				int accelerateInputCount = g_inputs.m_InputsBackward.Length + g_inputs.m_InputsForward.Length;
				float accelRatio = (g_inputs.m_InputsForward.Length - g_inputs.m_InputsBackward.Length) / (Math::Max(accelerateInputCount, 1));
				g_inputs.m_inputBrake = (accelRatio >= 0.0 ? 0.0 : 0.0 - accelRatio);
				g_inputs.m_inputAccelerate = (accelRatio > 0.0) || (Setting_AutoAccelerate && accelRatio >= 0.0);

				array<string> inputData; // 0: steering 1: brake 2: accelerate
				inputData.InsertLast(tostring(g_inputs.m_inputSteer));
				inputData.InsertLast(tostring(g_inputs.m_inputBrake * 0.65)); // 65% brake is basically 100% normal
				inputData.InsertLast(tostring(g_inputs.m_inputAccelerate));
				SendCustomEvent("TwitchPlays.Input", inputData);
			}

			if (g_inputs.m_InputRespawn) {
				SendCustomEvent("TwitchPlays.Respawn", {});
				g_overlay.m_lastRespawn = Time::Now;
				g_inputs.m_InputRespawn = false;
			}
		}

		yield();
	}
}